Robot Simulator of the Robotics Group for Self-Organization of Control: Base Class Reference

- Main Page
- Namespaces
- Classes
- Files
- Directories
- Related Pages
- Examples

- Search for |

- Alphabetical List
- Class List
- Class Hierarchy
- Class Members

# Base Class Reference

`#include <base.h>`

Inherits BackCaller.

Inherited by Simulation.

Inheritance diagram for Base:

[legend]
Collaboration diagram for Base:

[legend]
List of all members.

## Public Member Functions
| Base (const std::string &caption="lpzrobots Simulator Martius, Der, Guettler")
virtual void | makePhysicsScene ()
| create the ground plane
virtual osg::Group * | makeScene ()
| create the graphics of the sky and floor
virtual osg::Node * | makeSky ()
virtual osg::Node * | makeGround ()
virtual osg::Node * | createHUD ()
virtual osg::LightSource * | makeLights (osg::StateSet *stateset)
virtual osg::Group * | createShadowedScene (osg::Node *shadowed, osg::Vec3 posOfLight, unsigned int unit)
virtual osgShadow::ShadowedScene * | createShadowedScene (osg::Node *sceneToShadow, osg::LightSource *lightSource, int shadowType)
| Shadow types: 1 - ShadowVolume 2 - ShadowTextue 3 - ParallelSplitShadowMap 4 - SoftShadowMap 5 - ShadowMap.
virtual void | setGroundTexture (const char *filename)
virtual void | setCaption (const std::string &caption)
virtual HUDStatisticsManager * | getHUDSM ()
| Create HUDStatisticsManager and register it for being called back every step.
virtual | ~Base ()
## Static Public Member Functions
static int | contains (char **list, int len, const char *str)
| returns the index+1 if the list contains the given string or 0 if not
## Static Public Attributes
static const int | PHYSICS_CALLBACKABLE = 1
| called each ode/physics step
static const int | GRAPHICS_CALLBACKABLE = 2
| called each osg/draw step
## Protected Member Functions
virtual void | setTimeStats (double time, double realtimefactor, double truerealtimefactor, bool pause)
virtual void | changeShadowTechnique ()
| Changes the currently used shadow technique.
## Protected Attributes
dGeomID | ground
OsgHandle | osgHandle
OdeHandle | odeHandle
std::string | caption
std::string | groundTexture
osg::Group * | root
osgShadow::ShadowedScene * | shadowedScene
osg::LightSource * | lightSource
osg::Group * | sceneToShadow
osg::Node * | groundScene
osg::Transform * | transform
osg::Node * | hud
osgText::Text * | timestats
osgText::Text * | captionline
osgText::Text * | statisticLine
Primitive * | plane
HUDStatisticsManager * | hUDStatisticsManager
| this manager provides methods for displaying statistics on the graphical window!
std::list< Callbackable * > | graphicsCallbackables
std::vector< Callbackable * > | physicsCallbackables
int | ReceivesShadowTraversalMask
int | CastsShadowTraversalMask
int | shadow
int | shadowTexSize
bool | useNVidia

## Constructor & Destructor Documentation

Base | ( | const std::string & | caption = `"lpzrobots Simulator Martius, Der, Guettler"` | ) |

~Base | ( |  | ) | `[virtual]`

## Member Function Documentation

void changeShadowTechnique | ( |  | ) | `[protected, virtual]`

Changes the currently used shadow technique.

The switch is realized between: 0 - NoShadow 3 - ParallelSplitShadowMap 4 - SoftShadowMap 5 - ShadowMap (simple) Currently not supported by this function: 1 - ShadowVolume 2 - ShadowTextue

int contains | ( | char ** | list,
|  | int | len,
|  | const char * | str |
| ) |  |  | `[static]`

returns the index+1 if the list contains the given string or 0 if not

osg::Node * createHUD | ( |  | ) | `[virtual]`

virtual osgShadow::ShadowedScene* createShadowedScene | ( | osg::Node * | sceneToShadow,
|  | osg::LightSource * | lightSource,
|  | int | shadowType |
| ) |  |  | `[virtual]`

Shadow types: 1 - ShadowVolume 2 - ShadowTextue 3 - ParallelSplitShadowMap 4 - SoftShadowMap 5 - ShadowMap.

osg::Group * createShadowedScene | ( | osg::Node * | shadowed,
|  | osg::Vec3 | posOfLight,
|  | unsigned int | unit |
| ) |  |  | `[virtual]`

HUDStatisticsManager * getHUDSM | ( |  | ) | `[virtual]`

Create HUDStatisticsManager and register it for being called back every step.

But do not display if the system is initialised with -nographics.

Returns:
  the actual HUDStatisticsManager

Node * makeGround | ( |  | ) | `[virtual]`

osg::LightSource * makeLights | ( | osg::StateSet * | stateset | ) | `[virtual]`

void makePhysicsScene | ( |  | ) | `[virtual]`

create the ground plane

Group * makeScene | ( |  | ) | `[virtual]`

create the graphics of the sky and floor

Node * makeSky | ( |  | ) | `[virtual]`

void setCaption | ( | const std::string & | caption | ) | `[virtual]`

virtual void setGroundTexture | ( | const char * | filename | ) | `[inline, virtual]`

void setTimeStats | ( | double | time,
|  | double | realtimefactor,
|  | double | truerealtimefactor,
|  | bool | pause |
| ) |  |  | `[protected, virtual]`

## Member Data Documentation

std::string caption`[protected]`

osgText::Text* captionline`[protected]`

int CastsShadowTraversalMask`[protected]`

const int GRAPHICS_CALLBACKABLE = 2`[static]`

called each osg/draw step

std::list<Callbackable*> graphicsCallbackables`[protected]`

dGeomID ground`[protected]`

osg::Node* groundScene`[protected]`

std::string groundTexture`[protected]`

osg::Node* hud`[protected]`

HUDStatisticsManager* hUDStatisticsManager`[protected]`

this manager provides methods for displaying statistics on the graphical window!

osg::LightSource* lightSource`[protected]`

OdeHandle odeHandle`[protected]`

OsgHandle osgHandle`[protected]`

const int PHYSICS_CALLBACKABLE = 1`[static]`

called each ode/physics step

std::vector<Callbackable*> physicsCallbackables`[protected]`

Primitive* plane`[protected]`

int ReceivesShadowTraversalMask`[protected]`

osg::Group* root`[protected]`

osg::Group* sceneToShadow`[protected]`

int shadow`[protected]`

osgShadow::ShadowedScene* shadowedScene`[protected]`

int shadowTexSize`[protected]`

osgText::Text* statisticLine`[protected]`

osgText::Text* timestats`[protected]`

osg::Transform* transform`[protected]`

bool useNVidia`[protected]`

The documentation for this class was generated from the following files:

- base.h
- base.cpp